program Sprites_appender;

  uses Dos;

  var sprpath,archpath:pathstr;
      fin,fout:file of byte;
      i,size:longint;
      dx,dy:word;
      b1,b2:byte;

  function AdjustFilename(var path:pathstr; ext2:extstr):boolean;
    var dir:dirstr;
        name:namestr;
        ext:extstr;
    begin
      FSplit(path,dir,name,ext);
      if ext='' then ext:=ext2;
      if ext<>ext2 then
        begin
          WriteLn('Incorrect extension, must be ',ext2); WriteLn;
          AdjustFilename:=false;
        end
      else
        begin path:=dir+name+ext; AdjustFilename:=true; end;
    end;


  procedure ArchiveContents;
    var nbofsprites,archivesize:longint;
    begin
      Assign(fin,archpath); Reset(fin);
      nbofsprites:=0; archivesize:=0;
      while not EoF(fin) do
        begin
          Read(fin,b1,b2); dx:=b2*256+b1;
          Read(fin,b1,b2); dy:=b2*256+b1;
          size:=dx*dy;
          for i:=0 to size-1 do Read(fin,b1);
          Inc(nbofsprites);
          Inc(archivesize,size+4);
        end;
      WriteLn('sprites in archive: ',nbofsprites);
      WriteLn('archive size: ',archivesize);
      WriteLn;
    end;


  procedure Append(sprpath:pathstr);
    begin
      if not AdjustFilename(sprpath,'.spr') then Exit;
      Assign(fin,sprpath); {$I-} Reset(fin); {$I+}
      if IOResult<>0 then
        begin WriteLn(sprpath,' not found'); WriteLn; Exit; end;

      Read(fin,b1,b2); dx:=b2*256+b1;
      Read(fin,b1,b2); dy:=b2*256+b1;
      size:=dx*dy;

      Assign(fout,archpath); Reset(fout);

      Seek(fout,FileSize(fout));
      WriteLn('sprite position: ',FilePos(fout)); WriteLn;
      b1:=dx mod 256; b2:=dx div 256; Write(fout,b1,b2);
      b1:=dy mod 256; b2:=dy div 256; Write(fout,b1,b2);
      for i:=1 to size do
        begin Read(fin,b1); Write(fout,b1); end;
      Close(fout); Close(fin);
    end;


  begin
    WriteLn('Enter [path\]archname[.sps] of archive file');
    ReadLn(archpath);
    if not AdjustFilename(archpath,'.sps') then Exit;
    Assign(fin,archpath); {$I-} Reset(fin); {$I+}
    if IOResult<>0 then
        begin
          WriteLn(archpath,' not found, created new');
          Rewrite(fin); Close(fin);
        end;
    WriteLn;

    repeat
      WriteLn('Enter [path\]sprname[.spr] of appended sprite, or keyword'+
              ' ''CONTENTS'' for contens of archive, or ''EXIT'' for exit'+
              ' appender');
      ReadLn(sprpath);

      if sprpath='CONTENTS' then ArchiveContents
      else if sprpath<>'EXIT' then Append(sprpath);

    until sprpath='EXIT';
end.
